#
# Conditional build:
%bcond_without	dotnet		# C#/Mono binding
%bcond_without	java		# Java binding
#
%ifnarch %{ix86} %{x8664} alpha arm hppa ia64 mips ppc s390 s390x sparc sparcv9
%undefine	with_dotnet
%endif
%ifarch i386
%undefine	with_dotnet
%endif

%{?with_dotnet:%include	/usr/lib/rpm/macros.mono}
Summary:	Graphics library that outputs text instead of pixels
Summary(pl.UTF-8):	Biblioteka graficzna wyświetlająca tekst zamiast pikseli
Name:		libcaca
Version:	0.99
%define	subver	beta18
Release:	0.%{subver}.1
License:	WTFPL v2
Group:		Libraries
Source0:	http://libcaca.zoy.org/files/libcaca/%{name}-%{version}.%{subver}.tar.gz
# Source0-md5:	93d35dbdb0527d4c94df3e9a02e865cc
Patch0:		install.patch
Patch1:		%{name}-ruby1.9.patch
Patch2:		%{name}-format.patch
Patch3:		%{name}-monodir.patch
URL:		http://libcaca.zoy.org/
BuildRequires:	OpenGL-devel
BuildRequires:	autoconf >= 2.50
BuildRequires:	automake
BuildRequires:	doxygen
BuildRequires:	freeglut-devel >= 2.0.0
# not used
#BuildRequires:	ftgl-devel >= 2.1.3
BuildRequires:	imlib2-devel
%{?with_java:BuildRequires:	jdk}
BuildRequires:	libstdc++-devel
BuildRequires:	libtool >= 2:1.5
%{?with_dotnet:BuildRequires:	mono-csharp}
BuildRequires:	python-devel >= 2.2
BuildRequires:	pkgconfig
BuildRequires:	rpmbuild(macros) >= 1.533
BuildRequires:	rpmbuild(monoautodeps)
BuildRequires:	ruby-devel
BuildRequires:	sed >= 4.0
BuildRequires:	slang-devel >= 2.0.0
BuildRequires:	texlive-fonts-jknappen
BuildRequires:	texlive-format-pdflatex
BuildRequires:	texlive-makeindex
BuildRequires:	texlive-latex-ams
BuildRequires:	xorg-lib-libX11-devel
BuildRequires:	zlib-devel
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		specflags	-fomit-frame-pointer

%description
The libcaca library is a graphics library that outputs text instead of
pixels, so that it can work on older video cards or text terminals. It
is not unlike the famous AAlib library.

The differences with AAlib are the following:
- 16 available colours for character output (256 colour pairs)
- dithering of colour images
- basic sprite primitives

But libcaca also has the following limitations:
- no support for brightness, contrast, gamma
- unefficient character-choosing algorithms
- no raw keyboard support

%description -l pl.UTF-8
Biblioteka libcaca to biblioteka graficzna wyświetlająca tekst zamiast
pikseli, dzięki czemu może działać na starszych kartach graficznych
oraz terminalach tekstowych. Pod tym względem jest podobna do słynnej
biblioteki AAlib.

Różnice w stosunku do AAlib są następujące:
- 16 dostępnych kolorów dla znaków (256 par kolorów)
- dithering kolorowych obrazów
- proste kształty duszków (sprites)

Ale libcaca ma także następujące ograniczenia:
- brak obsługi jasności, kontrastu, korekcji gamma
- mało wydajne algorytmy wyboru znaków
- brak obsługi klawiatury w trybie surowym

%package plugin-GL
Summary:	GL plugin for libcaca library
Summary(pl.UTF-8):	Wtyczka GL dla biblioteki libcaca
Group:		Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	freeglut >= 2.0.0

%description plugin-GL
GL plugin for libcaca library.

%description plugin-GL -l pl.UTF-8
Wtyczka GL dla biblioteki libcaca.

%package plugin-X11
Summary:	X11 plugin for libcaca library
Summary(pl.UTF-8):	Wtyczka X11 dla biblioteki libcaca
Group:		Libraries
Requires:	%{name} = %{version}-%{release}

%description plugin-X11
X11 plugin for libcaca library.

%description plugin-X11 -l pl.UTF-8
Wtyczka X11 dla biblioteki libcaca.

%package img
Summary:	libcaca-based image viewer and converter
Summary(pl.UTF-8):	Przeglądarka i konwerter obrazków oparte na libcaca
Group:		Applications/Graphics

%description img
libcaca-based image viewer and converter. They use imlib2 to load
images.

%description img -l pl.UTF-8
Przeglądarka i konwerter obrazków oparte na libcaca. Do wczytywania
obrazków używają biblioteki imlib2.

%package devel
Summary:	Header files for libcaca library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki libcaca
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	slang-devel >= 2.0.0

%description devel
Header files for libcaca library.

%description devel -l pl.UTF-8
Pliki nagłówkowe biblioteki libcaca.

%package static
Summary:	Static libcaca library
Summary(pl.UTF-8):	Statyczna biblioteka libcaca
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static libcaca library.

%description static -l pl.UTF-8
Statyczna biblioteka libcaca.

%package c++
Summary:	C++ bindings for libcaca
Summary(pl.UTF-8):	Wiązania C++ do libcaca
Group:		Libraries
Requires:	%{name} = %{version}-%{release}

%description c++
C++ bindings for libcaca.

%description c++ -l pl.UTF-8
Wiązania C++ do libcaca.

%package c++-devel
Summary:	C++ bindings for libcaca - header files
Summary(pl.UTF-8):	Wiązania C++ do libcaca - pliki nagłówkowe
Group:		Development/Libraries
Requires:	%{name}-c++ = %{version}-%{release}
Requires:	%{name}-devel = %{version}-%{release}
Requires:	libstdc++-devel

%description c++-devel
C++ bindings for libcaca - header files.

%description c++-devel -l pl.UTF-8
Wiązania C++ do libcaca - pliki nagłówkowe.

%package c++-static
Summary:	C++ bindings for libcaca - static libraries
Summary(pl.UTF-8):	Wiązania C++ do libcaca - biblioteki statyczne
Group:		Development/Libraries
Requires:	%{name}-c++-devel = %{version}-%{release}

%description c++-static
C++ bindings for libcaca - static libraries.

%description c++-static -l pl.UTF-8
Wiązania C++ do libcaca - biblioteki statyczne.

%package -n dotnet-caca-sharp
Summary:	C# bindings for libcaca
Summary(pl.UTF-8):	Wiązania C# do libcaca
Group:		Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	mono

%description -n dotnet-caca-sharp
C# bindings for libcaca.

%description -n dotnet-caca-sharp -l pl.UTF-8
Wiązania C# do libcaca.

%package -n java-caca
Summary:	Java bindings for libcaca
Summary(pl.UTF-8):	Wiązania Javy do libcaca
Group:		Libraries/Java
Requires:	%{name} = %{version}-%{release}
Requires:	jre

%description -n java-caca
Java bindings for libcaca.

%description -n java-caca -l pl.UTF-8
Wiązania Javy do libcaca.

%package -n python-caca
Summary:	Python bindings for libcaca
Summary(pl.UTF-8):	Wiązania Pythona do libcaca
Group:		Development/Languages/Python
Requires:	%{name} = %{version}-%{release}
# ctypes
Requires:	python-modules

%description -n python-caca
Python bindings for libcaca.

%description -n python-caca -l pl.UTF-8
Wiązania Pythona do libcaca.

%package -n ruby-caca
Summary:	Ruby bindings for libcaca
Summary(pl.UTF-8):	Wiązania języka Ruby do libcaca
Group:		Development/Languages
Requires:	%{name} = %{version}-%{release}
%{?ruby_ver_requires_eq}

%description -n ruby-caca
Ruby bindings for libcaca.

%description -n ruby-caca -l pl.UTF-8
Wiązania języka Ruby do libcaca.

%prep
%setup -q -n %{name}-%{version}.%{subver}
%undos */Makefile.am
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1

%build
%{__libtoolize}
%{__aclocal}
%{__autoconf}
%{__autoheader}
%{__automake}
# NOTE: ncurses driver builds, but there's no color when linked against
# ABI 6. While caca defaults to ncurses this must be disabled until fixed.
%configure \
	--disable-ncurses \
	--enable-csharp%{!?with_dotnet:=no} \
	--enable-cxx \
	--enable-gl \
	--enable-java%{!?with_java:=no} \
	--enable-plugins \
	--enable-slang \
	--enable-x11


# ObjC file not used, use plain CC to link library to avoid C++/ObjC deps
%{__make} %{?with_java:-j1} \
	CLASSPATH=$(pwd)/java \
	OBJC="%{__cc}" \
	jnidir=%{_libdir}

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT \
	jnidir=%{_libdir}

# replace symlink by groff include
%{__rm} $RPM_BUILD_ROOT%{_mandir}/man1/cacademo.1
echo '.so cacafire.1' > $RPM_BUILD_ROOT%{_mandir}/man1/cacademo.1

# loadable modules
%{__rm} $RPM_BUILD_ROOT%{_libdir}/caca/*.{a,la}
%{__rm} $RPM_BUILD_ROOT%{ruby_sitearchdir}/*.la
%if %{with java}
%{__rm} $RPM_BUILD_ROOT%{_libdir}/libcaca-java.la
%endif
# man3 pages have too common base names to be included
%{__rm} $RPM_BUILD_ROOT%{_mandir}/man3/*.3caca
# packaged as %doc in -devel
%{__rm} -r $RPM_BUILD_ROOT%{_docdir}/lib{caca,cucul}-dev

cd $RPM_BUILD_ROOT%{_libdir}
for i in libcaca.so.*.*.* libcaca++.so.*.*.*; do
	ln -sf $i $(echo $i |sed 's/caca/cucul/')
done
ln -sf libcaca.a	$RPM_BUILD_ROOT%{_libdir}/libcucul.a
ln -sf libcaca.la	$RPM_BUILD_ROOT%{_libdir}/libcucul.la
ln -sf libcaca.so	$RPM_BUILD_ROOT%{_libdir}/libcucul.so
ln -sf libcaca.so.0 	$RPM_BUILD_ROOT%{_libdir}/libcucul.so.0
ln -sf libcaca++.a	$RPM_BUILD_ROOT%{_libdir}/libcucul++.a
ln -sf libcaca++.la	$RPM_BUILD_ROOT%{_libdir}/libcucul++.la
ln -sf libcaca++.so 	$RPM_BUILD_ROOT%{_libdir}/libcucul++.so
ln -sf libcaca++.so.0 	$RPM_BUILD_ROOT%{_libdir}/libcucul++.so.0
ln -sf caca++.h 	$RPM_BUILD_ROOT%{_includedir}/cucul++.h
ln -sf caca_types.h 	$RPM_BUILD_ROOT%{_includedir}/cucul_types.h

%py_postclean

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%post	c++ -p /sbin/ldconfig
%postun	c++ -p /sbin/ldconfig

%post	-n java-caca -p /sbin/ldconfig
%postun	-n java-caca -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc AUTHORS COPYING ChangeLog NEWS NOTES README THANKS
%attr(755,root,root) %{_bindir}/cacaclock
%attr(755,root,root) %{_bindir}/cacademo
%attr(755,root,root) %{_bindir}/cacafire
%attr(755,root,root) %{_bindir}/cacaplay
%attr(755,root,root) %{_bindir}/cacaserver
%attr(755,root,root) %{_libdir}/libcaca.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libcaca.so.0
%attr(755,root,root) %{_libdir}/libcucul.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libcucul.so.0
%dir %{_libdir}/caca
%{_datadir}/%{name}
%{_mandir}/man1/cacademo.1*
%{_mandir}/man1/cacafire.1*
%{_mandir}/man1/cacaplay.1*
%{_mandir}/man1/cacaserver.1*

%files plugin-GL
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/caca/libgl_plugin.so*

%files plugin-X11
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/caca/libx11_plugin.so*

%files img
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/cacaview
%attr(755,root,root) %{_bindir}/img2txt
%{_mandir}/man1/cacaview.1*
%{_mandir}/man1/img2txt.1*

%files devel
%defattr(644,root,root,755)
%doc doc/html/*
%attr(755,root,root) %{_bindir}/caca-config
%attr(755,root,root) %{_libdir}/libcaca.so
%attr(755,root,root) %{_libdir}/libcucul.so
%{_libdir}/libcaca.la
%{_libdir}/libcucul.la
%{_includedir}/caca.h
%{_includedir}/caca0.h
%{_includedir}/caca_conio.h
%{_includedir}/caca_types.h
%{_includedir}/cucul.h
%{_includedir}/cucul_types.h
%{_pkgconfigdir}/caca.pc
%{_pkgconfigdir}/cucul.pc
%{_mandir}/man1/caca-config.1*
# man3 pages have too common base names to be included

%files static
%defattr(644,root,root,755)
%{_libdir}/libcaca.a
%{_libdir}/libcucul.a

%files c++
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libcaca++.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libcaca++.so.0
%attr(755,root,root) %{_libdir}/libcucul++.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libcucul++.so.0

%files c++-devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libcaca++.so
%attr(755,root,root) %{_libdir}/libcucul++.so
%{_libdir}/libcaca++.la
%{_libdir}/libcucul++.la
%{_includedir}/caca++.h
%{_includedir}/cucul++.h
%{_pkgconfigdir}/caca++.pc
%{_pkgconfigdir}/cucul++.pc

%files c++-static
%defattr(644,root,root,755)
%{_libdir}/libcaca++.a
%{_libdir}/libcucul++.a

%if %{with dotnet}
%files -n dotnet-caca-sharp
%defattr(644,root,root,755)
%{_prefix}/lib/mono/caca-sharp-0.0
%{_prefix}/lib/mono/gac/caca-sharp
%{_javadir}/libjava.jar
%endif

%if %{with dotnet}
%files -n java-caca
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libcaca-java.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libcaca-java.so.0
%attr(755,root,root) %{_libdir}/libcaca-java.so
%endif

%files -n python-caca
%defattr(644,root,root,755)
%dir %{py_sitescriptdir}/caca
%{py_sitescriptdir}/caca/*.py[co]

%files -n ruby-caca
%defattr(644,root,root,755)
%{ruby_sitelibdir}/caca.rb
%attr(755,root,root) %{ruby_sitearchdir}/caca.so
%changelog
* Wed Dec 05 2012 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/libcaca.git;a=log;h=master

* Wed Dec 05 2012 Jakub Bogusz <qboosh@pld-linux.org> 2b03814
- try make -j1 for java

* Wed Dec 05 2012 Jakub Bogusz <qboosh@pld-linux.org> 5e3ad4c
- added monodir patch (fix mono binding install on lib64 systems)

* Wed Dec 05 2012 Jakub Bogusz <qboosh@pld-linux.org> eafd6e8
- setup CLASSPATH for java compilation using icedtea

* Wed Dec 05 2012 Jakub Bogusz <qboosh@pld-linux.org> 7efddf0
- texlive deps

* Tue Dec 04 2012 Jakub Bogusz <qboosh@pld-linux.org> c1bbb02
- more format workarounds

* Tue Dec 04 2012 Jakub Bogusz <qboosh@pld-linux.org> 6fc47a0
- more format workarounds

* Tue Dec 04 2012 Jakub Bogusz <qboosh@pld-linux.org> c4712b2
- added format patch to fix build with -Werror=format-security

* Tue Dec 04 2012 Jakub Bogusz <qboosh@pld-linux.org> 6ebb25e
- updated to 0.99.beta18
- enabled dotnet by default, added java and python bindings

* Mon Oct 17 2011 hawk <hawk@pld-linux.org> 633410a
- release 2

* Tue Mar 02 2010 Jan Rękorajski <baggins@pld-linux.org> 507ae18
- dsabled mono, there is something wrong with install

* Tue Mar 02 2010 Jan Rękorajski <baggins@pld-linux.org> 26cd819
- code fixes

* Tue Mar 02 2010 Jan Rękorajski <baggins@pld-linux.org> 24837e5
- fixed dir

* Tue Mar 02 2010 Jan Rękorajski <baggins@pld-linux.org> 26cf1af
- ruby 1.9 build fix

* Tue Mar 02 2010 Jan Rękorajski <baggins@pld-linux.org> 60afbba
- ruby 1.9 has headers in different place

* Tue Mar 02 2010 Jan Rękorajski <baggins@pld-linux.org> 2bda90e
- disabled java build, it's not even packaged

* Mon Mar 01 2010 Jan Rękorajski <baggins@pld-linux.org> cd27355
- updated to beta17

* Mon Mar 01 2010 Jan Rękorajski <baggins@pld-linux.org> 2ebb8b9
- rel 2

* Wed Feb 24 2010 sparky <sparky@pld-linux.org> 568d4d5
- undos before patching

* Wed Feb 24 2010 sparky <sparky@pld-linux.org> 2dbbea2
- BR: pkgconfig

* Wed Feb 24 2010 sparky <sparky@pld-linux.org> 7994831
- there was something wrong with this patch

